/*
  Calisto - An internet Talker
  Copyright (C) 1998-2001 Peter Howkins, Matthew Howkins and Simon Howkins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,     
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License   
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Email: calisto@calisto.cx

  $Id: plugin.c,v 1.3 2000/12/29 21:08:36 peter Exp $

 */
static const char rcsid[] = "$Id: plugin.c,v 1.3 2000/12/29 21:08:36 peter Exp $";

/* Plugin.c functions, using linux/solaris dlfcn.h and posix directory
   functions, platform specific */
#ifdef USE_PLUGINS

#include "dlfcn.h"
#include "sys/types.h"
#include "dirent.h"

#include "plugin.h"
#include "strplus.h"

static DIR *dir = 0;

/* --- dynamic linking functions */
/* open plugin fname and initailize a handle to it, return null on failure */
PLUGIN *plugin_open(const char *fname)
{
  char path[1024];
  strcpy(path, PLUGINDIR);
  strcat(path, fname);

  return dlopen(path, RTLD_LAZY);
}

void *plugin_get_symbol(PLUGIN *pl, char *symbol)
{
  return dlsym(pl, symbol);
}

/* return 0 for success, non zero for failure */
int plugin_close(PLUGIN *pl)
{
  return dlclose(pl);
}

/* --- directory functions */
int open_plugin_dir(void)
{
  dir = opendir(PLUGINDIR);
  if(dir)
    return 0;
  return 1;
}

int close_plugin_dir(void)
{
  return closedir(dir);
}

const char *next_plugin(void)
{
  struct dirent *d;

/*  if(dir) {
    d = readdir(dir);
    if(d)
      return d->d_name;
  }
  return 0;
*/
  while((d = readdir(dir)) != 0) {
    if(STREQ(".so", &d->d_name[strlen(d->d_name)-3]))
      break;
  }
  if(d)
    return d->d_name;
  return 0;
}

#else /* don't USE_PLUGINS */
static int gubbins = 0;
#endif /* USE_PLUGINS */
