#include <assert.h>

#include "pstruct.h"

#define STRLEN 80

struct additional {
  char   email[STRLEN];
  char     url[STRLEN];
  char  picurl[STRLEN];
  char irlname[STRLEN];
};

void on_finger(character *, character *, void *);
void on_save(INIFILE *, character *, void *);
void on_load(INIFILE *, character *, void *);


/* function prototypes for commands */
void command_info(character *, char *, const char *, void *);   

command clist[] = {
  { "email",   "",  command_info,    "n_base" },
  { "url",     "",  command_info,    "n_base" },
  { "picurl",  "",  command_info,    "n_base" },
  { "irlname", "",  command_info,    "n_base" },
  { NULL,    NULL,  NULL,             NULL     }
};

unsigned pversion = 1;

struct pheader p = {
  "Finger+",
  1,
  "Flibble",
  clist,
  sizeof(struct additional),
  on_finger,
  NULL,
  on_save,
  on_load,
  NULL,
  NULL,
  NULL,
  NULL,
  "additional.hlp"
}; 

void on_finger(character *c, character *vict, void *s)
{
  struct additional *t = s;

  if(!STREQ(t->email, ""))
    finger_item(c, "Email",    "%s", t->email);
  if(!STREQ(t->url, ""))
    finger_item(c, "Homepage", "%s", t->url);
  if(!STREQ(t->picurl, ""))
    finger_item(c, "Pic Url",  "%s", t->picurl);
  if(!STREQ(t->irlname, ""))
    finger_item(c, "IRL Name", "%s", t->irlname);

}


void on_save(INIFILE *ini, character *c, void *s)
{
  struct additional *t = s;

  inifile_set_token(ini, "email",   "%s", t->email);
  inifile_set_token(ini, "url",     "%s", t->url);
  inifile_set_token(ini, "picurl",  "%s", t->picurl);
  inifile_set_token(ini, "irlname", "%s", t->irlname);
}

void on_load(INIFILE *ini, character *c, void *s)
{
  struct additional *t = s;

  inifile_get_token(ini, "email",   "%s", t->email,   "");
  inifile_get_token(ini, "url",     "%s", t->url,     "");
  inifile_get_token(ini, "picurl",  "%s", t->picurl,  "");
  inifile_get_token(ini, "irlname", "%s", t->irlname, "");
}

void command_info(character *c, char *r, const char *comm, void *s)
{
  struct additional *t = s;

  if(STREQ(r, "")) {
    if(STREQ(comm, "email")) {
      STRNCOPY(t->email, "", sizeof(t->email));
    } else if (STREQ(comm, "url")) { 
      STRNCOPY(t->url, "", sizeof(t->url));
    } else if (STREQ(comm, "picurl")) { 
      STRNCOPY(t->picurl, "", sizeof(t->picurl));
    } else if (STREQ(comm, "irlname")) { 
      STRNCOPY(t->irlname, "", sizeof(t->irlname));
    }
    send_to_char(c, "You blank your '%s'\n", comm);
    return;
  } 

  if(STREQ(comm, "email")) {
    STRNCOPY(t->email, r, sizeof(t->email));
    send_to_char(c, "You set your '%s' to '%s'\n", comm, t->email);
  } else if (STREQ(comm, "url")) { 
    STRNCOPY(t->url, r, sizeof(t->url));
    send_to_char(c, "You set your '%s' to '%s'\n", comm, t->url);
  } else if (STREQ(comm, "picurl")) { 
    STRNCOPY(t->picurl, r, sizeof(t->picurl));
    send_to_char(c, "You set your '%s' to '%s'\n", comm, t->picurl);
  } else if (STREQ(comm, "irlname")) { 
    STRNCOPY(t->irlname, r, sizeof(t->irlname));
    send_to_char(c, "You set your '%s' to '%s'\n", comm, t->irlname);
  }
}
