#include <stdarg.h>

#include "pstruct.h"

void command_schan(character *, char *, const char *, void *);   

command clist[] = {
  { "su",   "",  command_schan,    "s_base" },
  { "se",   "",  command_schan,    "s_base" },
  { "ad",   "",  command_schan,    "a_base" },
  { "ae",   "",  command_schan,    "a_base" },
  { NULL,    NULL,  NULL,             NULL     }
};

unsigned pversion = 1;

struct pheader p = {
  "Static Channels",
  1,
  "Flibble",
  clist,
  0,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  "schans.hlp"
}; 

typedef struct {
  const char *tag;
  int (*function)(character *);
} channel;

int channel_ad(character *);
int channel_su(character *);

#define CHAN_AD 0
#define CHAN_SU 1

const channel channels[] = {
  { "^r[ad]",  channel_ad },
  { "^c[su]",  channel_su },
};

const unsigned channeln = sizeof channels / sizeof(channel);

void send_to_chan(int chan, const char *string, ...)
{
  char buffer[OUTPUT_BUFFER];
  va_list ptr;
  listnode *pNode = AllPlayers.head.next;
  int (*function)(character *) = NULL;

  /* does channel exist */
  if(chan > channeln)
    return;

  va_start(ptr, string);
  mvsnprintf(buffer, sizeof(buffer), string, ptr);
  va_end(ptr);

  function = channels[chan].function;

  while (LIST_NODE_IS_REAL(pNode)) {
    character *pChar = LIST_GET_DATA(pNode, character *, characterlink);
    if(function(pChar)) {
      send_to_char(pChar, "%s %s^n", channels[chan].tag, buffer);
    }
    pNode = pNode->next;
  }
}

void command_schan(character *c, char *r, const char *comm, void *s)
{
  if(STREQ(r, "")) {
    send_to_char(c, "Yes, but what do you want to send to channel?\n");
    return;
  }

  if(STREQ(comm, "su")) {
    send_to_chan(CHAN_SU, "%s says '%s'\n", GETNAME(c), r); 
  } else if(STREQ(comm, "se")) {
    send_to_chan(CHAN_SU, "%s %s\n", GETNAME(c), r); 
  } else if(STREQ(comm, "ad")) {
    send_to_chan(CHAN_AD, "%s says '%s'\n", GETNAME(c), r); 
  } else if(STREQ(comm, "ae")) {
    send_to_chan(CHAN_AD, "%s %s\n", GETNAME(c), r); 
  }
}

int channel_ad(character *c) 
{
  if(haspriv(c, "a_base"))
    return 1;
  return 0;
}

int channel_su(character *c) 
{
  if(haspriv(c, "s_base"))
    return 1;
  return 0;
}

